program brenner;  {Eprom brennen, lesen oder vergleichen}

uses lpt_bus,eprom,crt;

{$r-}

{Beim Brennen von Hex-Files werden unbekannt codierte Zeile einfach
bergangen! Bei Zeilen mit Prfsummenfehler gibt es eine Fehler-
meldung.}

type pbuffer=^tbuffer;
     tbuffer=array[0..1023] of byte;

var port:word;
    slot:byte;
    typ:byte;
    befehl:char;
    dateiname:string;
    start:word;
    zeit:byte;
    laenge:longint;

var ports:array[1..3] of word absolute $40:8;

procedure hilfe;
  begin
    writeln('Eprom-Brenner (c) Stefan Frings 1995');
    writeln('Schreibt und liest Binrdateien und Hex Dateien');
    writeln;
    writeln('Binrfiles brennen:');
    writeln('BRENNER Port Slot B Dateiname [Start] [Zeit]');
    writeln;
    writeln('Hex-Files brennen:');
    writeln('BRENNER Port Slot B Dateiname [Zeit]');
    writeln;
    writeln('Eprom lesen:');
    writeln('BRENNER Port Slot L Dateiname Start Laenge [Format]');
    writeln;
    writeln('Port       ist der Druckerport 1, 2 oder 3');
    writeln('Slot       ist der Steckplatz des Benners im Interface 0-15');
    writeln('Start      ist die Startposition im Eprom (dezimal)');
    writeln('Lnge      ist die Lnge der zu lesenden Daten (dezimal)');
    writeln('Zeit       ist Brennzeit des Eproms, wenn nicht angegeben 50ms');
    writeln('Format     ist das gewnschte Zielformat, Standart ist Binr');
    writeln('           bzw Intel, wenn der Dateiname mit ".HEX" endet.');
    writeln;
    writeln('Formate:     0 Binr       3 Motorola');
    writeln('             1 Intel       4 Mos Technology');
    writeln('             2 Elektor     5 Tektronix');
  end;

procedure getparams;
  var i:integer;
      s:string;
      f:file;
      o1,o2,o3:word;
  begin
    start:=0;
    laenge:=0;
    zeit:=50;
    val(paramstr(1),port,i);
    if (i<>0) or (port>3) or (port=0) then begin
      writeln('Ungltiger Druckerport.');
      halt;
    end;
    port:=ports[port];
    val(paramstr(2),slot,i);
    if (i<>0) or (slot>15) then begin
      writeln('Ungltiger Slot.');
      halt;
    end;
    s:=paramstr(3);
    befehl:=upcase(s[1]);
    if (befehl<>'L') and (befehl<>'B') then begin
      writeln('Ungltiger Befehl.');
      halt;
    end;
    dateiname:=paramstr(4);
    assign(f,dateiname);
    {$i-} reset(f,1); {$i+}
    if ioresult=0 then begin
      laenge:=filesize(f);
      if befehl='L' then begin
        write('Datei existiert schon. berschreiben? (j/n) ');
        readln(s);
        if (s<>'j') and (s<>'J') then
          halt;
      end;
    end else begin
      if Befehl<>'L' then begin
        writeln('Datei existiert nicht.');
        halt;
      end;
    end;
    if length(dateiname)>4 then
      s:=copy(dateiname,length(dateiname)-3,4)
    else
      s:='';
    for i:=1 to length(s) do
      s[i]:=upcase(s[i]);
    if s='.HEX' then
      typ:=1
    else
      typ:=0;
    if befehl='B' then begin
      if typ=0 then begin
        if paramcount>=5 then begin
          val(paramstr(5),start,i);
          if i<>0 then begin
            writeln('Ungltige Startadresse.');
            halt;
          end;
        end;
        if paramcount>=6 then begin
          val(paramstr(6),zeit,i);
          if i<>0 then begin
            writeln('Ungltige Brennzeit.');
            halt;
          end;
        end;
      end else begin
        if paramcount>=5 then begin
          val(paramstr(5),zeit,i);
          if i<>0 then begin
            writeln('Ungltige Brennzeit.');
            halt;
          end;
        end;
      end;
    end else begin
      if paramcount<6 then begin
        writeln('Zu wenig Parameter.');
        halt;
      end;
      val(paramstr(5),start,i);
      if i<>0 then begin
        writeln('Ungltige Startadresse.');
        halt(0);
      end;
      val(paramstr(6),laenge,i);
      if i<>0 then begin
        writeln('Ungltige Laenge.');
        halt(0);
      end;
      if paramcount>=7 then begin
        val(paramstr(7),typ,i);
        if (i<>0) or (i>5) then begin
          writeln('Ungltiges Zielformat');
          halt(0);
        end;
      end;
    end;
    if start+laenge-1>65535 then begin
      writeln('Das pat nicht einmal in ein 64KB Eprom!');
      halt(0);
    end;
  end;

procedure lesen_bin;
  var f:file of byte;
      w:word;
      b:byte;
  begin
    write('Lese Speicherzelle ');
    assign(f,dateiname);
    rewrite(f);
    for w:=start to start+laenge-1 do begin
      gotoxy(20,wherey);
      write(w);
      b:=eprom_read(w);
      write(f,b);
      if keypressed then
        if readkey=#27 then begin
          writeln(', abgebrochen');
          halt;
        end;
    end;
    close(f);
    writeln(', fertig.');
  end;

procedure brennen_bin;
  var f:file of byte;
      w:word;
      b:byte;
      fehler:word;
      taste:char;
  begin
    write('Brenne Speicherzelle ');
    assign(f,dateiname);
    reset(f);
    for w:=start to start+laenge-1 do begin
      gotoxy(22,wherey);
      write(w);
      read(f,b);
      if not eprom_write(w,b) then begin
        write(' Fehler. (A)bbrechen, (F)ortsetzen, (W)iederholen ?');
        while keypressed do readkey;
        taste:=readkey;
        if (taste='a') or (taste='A') then
          halt
        else if (taste='w') or (taste='W') then
          dec(w);
        gotoxy(22,wherey);
        write(' ':57);
      end;
      if keypressed then
        if readkey=#27 then begin
          writeln(', abgebrochen');
          halt;
        end;
    end;
    close(f);
    writeln(', fertig.');
  end;

function byte_to_hex(b:byte):string;
  var s:string[2];
      l,h:byte;
  begin
    l:=b and $F;
    h:=(b and $F0) shr 4;
    if l>9 then
      inc(l,7);
    if h>9 then
      inc(h,7);
    s:=chr(h+48);
    s:=s+chr(l+48);
    byte_to_hex:=s;
  end;

function word_to_hex(w:word):string;
  begin
    word_to_hex:=byte_to_hex(hi(w))+byte_to_hex(lo(w));
  end;

function make_hexstring(adresse:word;daten:string):string;
  var ziel:string;
      i:integer;
      b:byte; {8-Bit Prfsumme}
      w:word; {16-Bit Prfsumme}
  begin
    case typ of
      1:begin
          if length(daten)>120 then
            runerror; {String wrde zu lang werden}
          ziel:=':'+byte_to_hex(length(daten))+word_to_hex(adresse)+'00';
          b:=length(daten)+hi(adresse)+lo(adresse);
          for i:=1 to length(daten) do begin
            ziel:=ziel+byte_to_hex(byte(daten[i]));
            b:=b+byte(daten[i]);
          end;
          ziel:=ziel+byte_to_hex(not(b)+1);
        end;
      2:begin
          if length(daten)>80 then
            runerror; {String wrde zu lang werden}
          ziel:=byte_to_hex(length(daten))+' ';
          ziel:=ziel+word_to_hex(adresse)+':';
          w:=0;
          for i:=1 to length(daten) do begin
            ziel:=ziel+byte_to_hex(byte(daten[i]))+' ';
            w:=w+byte(daten[i]);
          end;
          ziel:=ziel+word_to_hex(w);
        end;
      3:begin
          if length(daten)>121 then
            runerror; {String wrde zu lang werden}
          ziel:='S1'+byte_to_hex(length(daten)+3)+word_to_hex(adresse);
          b:=length(daten)+hi(adresse)+lo(adresse);
          for i:=1 to length(daten) do begin
            ziel:=ziel+byte_to_hex(byte(daten[i]));
            b:=b+byte(daten[i]);
          end;
          ziel:=ziel+byte_to_hex($FF-b);
        end;
      4:begin
          if length(daten)>121 then
            runerror; {String wrde zu lang werden}
          ziel:=';'+byte_to_hex(length(daten))+word_to_hex(adresse);
          w:=length(daten)+hi(adresse)+lo(adresse);
          for i:=1 to length(daten) do begin
            ziel:=ziel+byte_to_hex(byte(daten[i]));
            w:=w+byte(daten[i]);
          end;
          ziel:=ziel+word_to_hex(w);
        end;
      5:begin
          if length(daten)>121 then
            runerror; {String wrde zu lang werden}
          ziel:='/'+word_to_hex(adresse)+byte_to_hex(length(daten));
          b:=hi(adresse)+lo(adresse)+length(daten);
          ziel:=ziel+byte_to_hex(b);
          b:=0;
          for i:=1 to length(daten) do begin
            ziel:=ziel+byte_to_hex(byte(daten[i]));
            b:=b+byte(daten[i]);
          end;
          ziel:=ziel+byte_to_hex(b);
        end;
    else
      runerror; {Unbekannter Hex-Typ}
    end;
    make_hexstring:=ziel;
  end;

function make_hexende:string;
  begin
    case typ of
      1:begin
          make_hexende:=':00000001FF';
        end;
      2:begin
          make_hexende:='';
        end;
      3:begin
          make_hexende:='S9030000FC';
        end;
      4:begin
          make_hexende:=';00';
        end;
      5:begin
          make_hexende:='/00000000';
        end;
    else
      runerror; {Unbekannter Typ}
    end;
  end;

procedure lesen_hex;
  var adresse:word;
      f:text;
      daten:string;
      ziel:word;
      anzahl:byte;
      i:integer;
  begin
    write('Lese Speicherzelle ');
    assign(f,dateiname);
    rewrite(f);
    adresse:=start;
    ziel:=start+laenge-1;
    repeat
      if ziel-adresse+1>16 then
        anzahl:=16
      else
        anzahl:=ziel-adresse+1;
      daten[0]:=char(anzahl);
      for i:=1 to anzahl do begin
        gotoxy(20,wherey);
        write(adresse+i-1);
        daten[i]:=char(eprom_read(adresse+i-1));
        if keypressed then
          if readkey=#27 then begin
            writeln(', abgebrochen');
            halt;
          end;
      end;
      daten:=make_hexstring(adresse,daten);
      writeln(f,daten);
      inc(adresse,anzahl);
    until adresse>ziel;
    daten:=make_hexende;
    writeln(f,daten);
    close(f);
    writeln(', fertig.');
  end;

function hex_to_word(s:string):word;
  var w:word;
      i:integer;
      b:byte;
  begin
    w:=0;
    i:=0;
    if length(s)=0 then
      exit;
    repeat
      inc(i);
      b:=ord(upcase(s[i]));
      if b>57 then
        dec(b,55)
      else
        dec(b,48);
      w:=w shl 4;
      w:=w or b;
    until i=length(s);
    hex_to_word:=w;
  end;

function ist_hexende(hexstr:string):boolean;
  var s:string;
  begin
    s:=make_hexende;
    hexstr:=copy(hexstr,1,length(s));
    ist_hexende:=(hexstr=s) and (s<>'');
  end;

function decode_hexstring(hexstr:string;var adresse:word):string;
  var check_w:word;
      check_b:byte;
      sollcheck_w:word;
      sollcheck_b:byte;
      anzahl:byte;
      ziel:string;
      i:integer;
  procedure falsche_crc;
    begin
      writeln('CRC-Summe falsch in:');
      writeln(hexstr);
      halt;
    end;
  begin
    decode_hexstring:='';
    if (hexstr[1]=':') and (hexstr[8]='0') and (hexstr[9]='0') then
      typ:=1
    else if (hexstr[8]=':') and (hexstr[3]=' ') then
      typ:=2
    else if (hexstr[1]='S') and (hexstr[2]='1') then
      typ:=3
    else if (hexstr[1]=';') then
      typ:=4
    else if (hexstr[1]='/') then
      typ:=5
    else
      exit;
    if ist_hexende(hexstr) then
      exit;
    case typ of
      1:begin
          anzahl:=hex_to_word(copy(hexstr,2,2));
          adresse:=hex_to_word(copy(hexstr,4,4));
          sollcheck_b:=hex_to_word(copy(hexstr,10+anzahl shl 1,2));
          check_b:=anzahl+hi(adresse)+lo(adresse);
          ziel[0]:=char(anzahl);
          for i:=1 to anzahl do begin
            ziel[i]:=char(hex_to_word(copy(hexstr,8+i shl 1,2)));
            check_b:=check_b+byte(ziel[i]);
          end;
          if byte(check_b+sollcheck_b)<>0 then
            falsche_crc;
        end;
      2:begin
          anzahl:=hex_to_word(copy(hexstr,1,2));
          adresse:=hex_to_word(copy(hexstr,4,4));
          sollcheck_w:=hex_to_word(copy(hexstr,9+anzahl*3,4));
          check_w:=0;
          ziel[0]:=char(anzahl);
          for i:=1 to anzahl do begin
            ziel[i]:=char(hex_to_word(copy(hexstr,6+i*3,2)));
            check_w:=check_w+byte(ziel[i]);
          end;
          if check_w<>sollcheck_w then
            falsche_crc;
        end;
      3:begin
          anzahl:=hex_to_word(copy(hexstr,3,2))-3;
          adresse:=hex_to_word(copy(hexstr,5,4));
          sollcheck_b:=hex_to_word(copy(hexstr,9+anzahl shl 1,2));
          check_b:=anzahl+hi(adresse)+lo(adresse);
          ziel[0]:=char(anzahl);
          for i:=1 to anzahl do begin
            ziel[i]:=char(hex_to_word(copy(hexstr,7+i shl 1,2)));
            check_b:=check_b+byte(ziel[i]);
          end;
          if check_b+sollcheck_b<>255 then
            falsche_crc;
        end;
      4:begin
          anzahl:=hex_to_word(copy(hexstr,2,2));
          adresse:=hex_to_word(copy(hexstr,4,4));
          sollcheck_w:=hex_to_word(copy(hexstr,8+anzahl shl 1,4));
          check_w:=anzahl+hi(adresse)+lo(adresse);
          ziel[0]:=char(anzahl);
          for i:=1 to anzahl do begin
            ziel[i]:=char(hex_to_word(copy(hexstr,6+i shl 1,2)));
            check_w:=check_w+byte(ziel[i]);
          end;
          if check_w<>+sollcheck_w then
            falsche_crc;
        end;
      5:begin
          anzahl:=hex_to_word(copy(hexstr,6,2));
          adresse:=hex_to_word(copy(hexstr,2,4));
          sollcheck_b:=hex_to_word(copy(hexstr,8,2));
          check_b:=anzahl+hi(adresse)+lo(adresse);
          if check_b<>sollcheck_b then
            falsche_crc;
          sollcheck_b:=hex_to_word(copy(hexstr,10+anzahl shl 1,2));
          check_b:=0;
          ziel[0]:=char(anzahl);
          for i:=1 to anzahl do begin
            ziel[i]:=char(hex_to_word(copy(hexstr,8+i shl 1,2)));
            check_b:=check_b+byte(ziel[i]);
          end;
          if check_b<>+sollcheck_b then
            falsche_crc;
        end;
    else
      runerror; {Unbekannter Typ}
    end;
    decode_hexstring:=ziel;
  end;

procedure brennen_hex;
  var f:text;
      zeile:string;
      adresse:word;
      daten:string;
      i:integer;
      taste:char;
  begin
    write('Brenne Speicherzelle ');
    zeile:='';
    assign(f,dateiname);
    reset(f);
    while not(eof(f)) and not(ist_hexende(zeile)) do begin
      readln(f,zeile);
      daten:=decode_hexstring(zeile,adresse);
      if daten<>'' then
        for i:=1 to length(daten) do begin
          gotoxy(22,wherey);
          write(adresse+i-1);
          if not eprom_write(adresse+i-1,byte(daten[i])) then begin
            write(' Fehler. (A)bbrechen, (F)ortsetzen, (W)iederholen ?');
            while keypressed do readkey;
            taste:=readkey;
            if (taste='a') or (taste='A') then
              halt
            else if (taste='w') or (taste='W') then
              dec(i);
            gotoxy(22,wherey);
            write(' ':57);
          end;
          if keypressed then
            if readkey=#27 then begin
              writeln(', abgebrochen');
              halt;
            end;
        end;
    end;
    close(f);
    writeln(', fertig.');
  end;

procedure init;
  begin;
    bus_setup(port,7,3,nil);
    eprom_setup(slot,zeit);
    eprom_read(0); {Dadurch wird der Eprom-Brenner ganz einfach initialisiert}
    writeln;
    writeln('- Stellen Sie die Codierschalter gem dem gewnschten Eprom ein.');
    writeln('- Setzen Sie das Eprom ein.');
    writeln('- Legen Sie die Programmierspannung Vpp an.');
    writeln;
    writeln('Wenn es losgehen kann, drcken Sie bitte Enter.');
    readln;
  end;

begin
  clrscr;
  writeln;
  if paramcount<4 then
    hilfe
  else begin
    getparams;
    init;
    if typ>0 then begin
      if befehl='L' then
        lesen_hex
      else
        brennen_hex;
    end else begin
      if befehl='L' then
        lesen_bin
      else
        brennen_bin;
    end;
  end;
end.